#! ruby -Ks
  # {ƂƕƂ̑Ă̑gp^[\Eۑ(ėp)
require "exlap"
require "csv"

    # Qzgroup̗vf́ugvĂԂ
    # group̗vfO̎ [] Ԃ
def combine(group)
  res = []
  if group.size == 1
    group[0].each {|x|
      res << [x]
    }
  elsif group.size == 2
    first = group[0]
    second = group[1]
    first.each {|x1|
      second.each {|x2|
        res << [x1, x2]
      }
    }
  elsif group.size > 2
    first = group[0]
    other = group[1...group.size]
    w = combine(other)
    first.each {|x|
      w.each {|ary|
        res << ([x] + ary)
      }
    }
  end
  return res
end

    # O`csv
cell_names_format = <<EON
^Cg
x
,,xo,v
,Ǝ,Ǝxo,Ɨv
Z,Z,Zxo,Zv
EON
cell_names = CSV.parse(cell_names_format)  # csvzɕϊ

    # Z̒lcsv
cell_values_format = <<EOV
2011Nx@ƕʎxv揑
,,xo,v
,,,=-xo
,,,=Ǝ-Ǝxo
Z,=+Ǝ,=xo+Ǝxo,=v+Ɨv
EOV
cell_values = CSV.parse(cell_values_format)  # csvzɕϊ

    # ViIcsv
scenario_data_csv = <<EOS
HX̃ViI,",,xo",HX,20000000,11300000
ʐM̔̃ViI,",,xo",ʐM̔,12000000,6680000
moc̃ViI,",,xo",moc,30000000,20520000
Ƃ`̃ViI,",Ǝ,Ǝxo",Ƃ`,1500000,100000
ƂãViI,",Ǝ,Ǝxo",Ƃa,1000000,50000
Ƃb̃ViI,",Ǝ,Ǝxo",Ƃb,750000,50000
EOS
scenario_data = CSV.parse(scenario_data_csv)  # csvzɕϊ

filename = "test03_3.xls"
Exlap.new(filename) {|wb|
  ss = wb.fes  # ̃[NV[gI
  ss.Name = "ƕʎxv揑"
      # ZɖOt
  cell_names.each_with_index {|list, r|
    list.each_with_index {|name, c|
      ss.Cells.Item(r+1, c+1).Name = name  if name.to_s != ''
    }
  }
      # Z̒lZbg
  cell_values.each_with_index {|list, r|
    list.each_with_index {|val, c|
      ss.Cells.Item(r+1, c+1).Value = val  if val.to_s != ''
    }
  }
  ss.rr(1,1, 1,cell_values[1].size).MergeCells = true  # ^Cg̃Z
      # ZɊւ邻̑̐ݒ
  (%w( xo v) +
   %w(Ǝ Ǝxo Ɨv) +
   %w(Z Zxo Zv)).each {|name|
      ss.Range(name).NumberFormatLocal = "#,##0"  # l̕\`
  }

      # ViI̓o^
  scenario_data.each {|ary|
    name = ary[0]
    changing_cells = ss.Range(ary[1])
    values = ary[2...ary.size]
    ss.Scenarios.Add({
        'Name'=>name,
        'ChangingCells'=>changing_cells,
        'Values'=>values})
  }

      # changing_cells肪ɂO[v
      # changing_cellŝ𓯂O[vƂ݂Ȃ
  group = []
  hs = {}
  scenario_data.each {|ary|
    name = ary[0]
    changing_cells = ary[1]
    num = hs[changing_cells]
    unless num
      num = hs[changing_cells] = hs.size
    end
    unless group[num]
      group[num] = []
    end
    group[num] << name
  }

  res = combine(group)
  res.each {|ary|
    ary.each {|name|
      ss.Scenarios(name).Show
    }
    ss.range_autofit  # Z̕ƍ
    ss.Copy({'Before'=>ss})  # V[g̑OɕV[gV
    ss2 = wb.offset_sheet(ss, -1)  # V݂̕V[g̃IuWFNg𓾂
    ss2.Name = ary.join("")
  }
  wb.save
}
